﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using Infragistics.Windows.DataPresenter;

namespace ItemsCheckedDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Page
    {
        private bool? allMemberChecked = false;
        
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = this;            
        }

        private void XamDataGrid_SelectedItemsChanged(object sender, Infragistics.Windows.DataPresenter.Events.SelectedItemsChangedEventArgs e)
        {
            if (AllMembersAreChecked == true || AllMembersAreChecked == false)
            {
                AllMembersAreChecked = null;
            }

            if (AllMembersAreChecked == null && myDataGrid.SelectedItems.Records.Count == 0)
            {
                AllMembersAreChecked = false;
            }
        }

        private void XamDataGrid_EditModeStarting(object sender, Infragistics.Windows.DataPresenter.Events.EditModeStartingEventArgs e)
        {
            e.Cell.Record.IsSelected = true;   
        }

        public bool? AllMembersAreChecked
        {
            get { return allMemberChecked; }
            set
            {
                if (value == true)
                {
                    foreach (Record myrecord in myDataGrid.RecordManager.GetFilteredInDataRecords())
                    {
                        myrecord.IsSelected = true;
                    }
                }
                if (value == false)
                {
                    foreach (Record myrecord in myDataGrid.RecordManager.GetFilteredInDataRecords())
                    {
                        myrecord.IsSelected = false;
                    }
                }
                allMemberChecked = value;
                this.OnPropertyChanged("AllMembersAreChecked");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(PropertyChangedEventArgs e)
        {
            var handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, e);
            }
        }

        protected void OnPropertyChanged(string propertyName)
        {
            this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }
    }    
}
